library default_text;

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
// import 'package:gayalo/app/config/constants.dart';

class DefText {
  final String text;
  final Color color;
  final double opacity;
  final FontStyle fontStyle;
  final FontWeight fontWeight;
  final int? maxLine;
  final TextAlign? textAlign;
  final TextDecoration? decoration;
  final Key? key;

  DefText(this.text,
      {this.maxLine,
      this.color = Colors.black,
      this.opacity = 1,
      this.fontStyle = FontStyle.normal,
      this.fontWeight = FontWeight.normal,
      this.textAlign,
      this.decoration,
      this.key});

  TextStyle get _defaultValue {
    return TextStyle(
      color: color.withOpacity(opacity),
      fontStyle: fontStyle,
      fontWeight: fontWeight,
      decoration: decoration,
    );
  }

  dynamic get extraSmall {
    if (kIsWeb) {
      Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 10.7),
        // overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    } else {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 10.7),
      );
    }
  }

  dynamic get small {
    if (kIsWeb) {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 10.7),
        // overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    } else {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 10.7),
        overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    }
  }

  dynamic get semiSmall {
    if (kIsWeb) {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 11.7),
        // overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    } else {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 11.7),
        overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    }
  }

  dynamic get normal {
    if (kIsWeb) {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 12.7),
        // overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    } else {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 12.7),
        overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    }
  }

  dynamic get semilarge {
    if (kIsWeb) {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 15.7),
        // overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    } else {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 15.7),
        overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    }
  }

  dynamic get large {
    if (kIsWeb) {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 17.7),
        // overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    } else {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 17.7),
        overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    }
  }

  dynamic get extraLarge {
    if (kIsWeb) {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 22.7),
        // overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    } else {
      return Text(
        text,
        key: key,
        maxLines: maxLine,
        textAlign: textAlign,
        style: _defaultValue.copyWith(fontSize: 22.7),
        overflow: maxLine != null ? TextOverflow.ellipsis : null,
      );
    }
  }
}

// class DefTextRenderer extends StatelessWidget {
//   const DefTextRenderer({
//     Key? key,
//     required this.text,
//   }) : super(key: key);

//   final Text text;

//   @override
//   Widget build(BuildContext context) {
//     return TextRenderer(
//       // element: ParagraphElement(),
//       text: text,
//     );
//   }
// }
